// $Header: /u/drspeech/repos/quicknet2/testsuite/tanh_test.cc,v 1.1 2006/05/24 01:00:35 davidj Exp $
//
// davidj - Thu Mar  2 21:28:36 1995
//
// Test of "mat" matlab format routines.

#include <assert.h>
#include <math.h>
#include <stdio.h>
#include <string.h>

#include "QN_types.h"
#include "QN_fltvec.h"

#include "rtst.h"


void
tanh_test()
{
    rtst_start("tanh_test");
    int test;
    double err, max_err;

    max_err = 0.0f;

    for (test = 0; test<rtst_numtests; test++)
    {
	float *in, *out1, *out2;
	size_t i;

	size_t size = rtst_urand_i32i32_i32(1, rtst_sizetests);
	in = rtst_padvec_new_vf(size);
	out1 = rtst_padvec_new_vf(size);
	out2 = rtst_padvec_new_vf(size);
	rtst_urand_ff_vf(size, -10.0, 10.0, in);
	qn_nv_tanh_vf_vf(size, in, out1);
	qn_pp_tanh_vf_vf(size, in, out2);
	for (i = 0; i<size; i++)
	{
	    err = fabs(out1[i] - out2[i]);
	    rtst_log("nv=%f pp=%f err=%f\n", out1[i], out2[i], err);
	    if (err>max_err)
		max_err = err;
	}
	rtst_padvec_del_vf(out2);
	rtst_padvec_del_vf(out1);
	rtst_padvec_del_vf(in);

    }
    rtst_log("max_err=%f\n", max_err);
    rtst_passed();
}


int
main(int argc, char* argv[])
{
    int arg;

    arg = rtst_args(argc, argv);

//    assert(arg == argc);
    tanh_test();
    rtst_exit();
}

